'
'  **************************************************
'  *                                                *
'  *                   LCM.BAS                      *
'  *                                                *
'  *         Compute Least Common Multiple          *
'  *           using Euclid's Algorithm             *
'  *                                                *
'  *              Judson D. McClendon               *
'  *              Sun Valley Systems                *
'  *              4522 Shadow Ridge Pkwy            *
'  *              Pinson, AL 35126-2192             *
'  *                 205-680-0460                   *
'  *                                                *
'  **************************************************
'
DECLARE FUNCTION GCD& (BYVAL A AS LONG, BYVAL B AS LONG)
PRINT "Least Common Multiple"
DIM A AS LONG, B AS LONG

INPUT "Enter A,B: ", A, B
IF (A * B) THEN
   PRINT "LCM ="; A * B / GCD&(A, B)
END IF
END

'
' Greatest Common Divisor: GCD(A,B) using Euclid's Algorithm
'
FUNCTION GCD& (BYVAL A AS LONG, BYVAL B AS LONG)
   DIM T AS LONG

   WHILE (B)
      T = A MOD B
      A = B
      B = T
   WEND
   GCD& = A
END FUNCTION

