'
'  **************************************************
'  *                                                *
'  *                  LONGEST.BAS                   *
'  *                                                *
'  *       Display Longest Line in ASCII File       *
'  *                                                *
'  *              Judson D. McClendon               *
'  *              Sun Valley Systems                *
'  *              4522 Shadow Ridge Pkwy            *
'  *              Pinson, AL 35126-2192             *
'  *                 205-680-0460                   *
'  *                                                *
'  **************************************************
'
DEFINT A-Z

FileName$ = COMMAND$
IF FileName$ = "" THEN
   INPUT "Enter file name: ", FileName$
END IF
OPEN "I", #1, FileName$

RecordNumber = 0
MaxLength = 0
WHILE NOT EOF(1)
   LINE INPUT #1, Record$
   RecordNumber = RecordNumber + 1
   Length = LEN(Record$)
   IF Length > MaxLength THEN
      MaxRecord = RecordNumber
      MaxLength = Length
      MaxLine$ = Record$
   END IF
WEND

CLOSE #1

PRINT "File "; FileName$; ", maximum line length is"; MaxLength
PRINT USING "#####: &"; MaxRecord, MaxLine$
