' MORSE.BAT - Morse Code Generator With PC-Speaker Sound
' =========
' With corrections by Lothar Hartmann (lothar.hartmann@mdcc-fun.de)
'===================================================================
DECLARE SUB letter (char2)
DECLARE SUB Init ()
CLS
DIM SHARED char$(45), ditdahspace, charspace, wordspace, dit, dah, f
CALL Init
dit = .07
dit = dit * 18.2
dah = dit * 3
ditdahspace = dit
charspace = dit * 3
wordspace = dit * 6     '5 for automatic transmission
                        'send eight dots to tell to delete last word

DO
 y = y + 2
 IF y > 23 THEN CLS : y = 1
 COLOR 7
 PRINT "Zum Beenden ENTER druecken"
 INPUT "Message: ", mes$
 IF mes$ = "" THEN END
 mes$ = UCASE$(mes$)

 FOR f = 1 TO LEN(mes$)
  char = ASC(MID$(mes$, f, 1))
 
  SELECT CASE char
        CASE 34: CALL letter(45)
        CASE 39: CALL letter(42)
        CASE 40: CALL letter(44)
        CASE 41: CALL letter(44)
        CASE 63: CALL letter(39)
        CASE 44: CALL letter(38)
        CASE 45: CALL letter(41)
        CASE 46: CALL letter(37)
        CASE 47: CALL letter(43)
        CASE 32: SOUND 0, wordspace: LOCATE 1, 70: COLOR 7: PRINT "WDS"
        CASE ELSE
        IF char >= 48 AND char <= 58 THEN CALL letter(char - 21)
        IF char >= 65 AND char <= 90 THEN CALL letter(char - 64)
  END SELECT
  IF char = 32 THEN
        ELSE
        IF f < LEN(mes$) THEN
               IF ASC(MID$(mes$, f + 1, 1)) = 32 THEN  ELSE SOUND 0, charspace: LOCATE 1, 70: COLOR 7: PRINT "CHS"
               END IF
  END IF
 COLOR 15: LOCATE 1 + y, f + 9: PRINT UCASE$(CHR$((char)))
NEXT f
LOOP

END

SUB Init
char$(1) = "01"          'a
char$(2) = "1000"         'b
char$(3) = "1010"         'c
char$(4) = "100"          'd
char$(5) = "0"            'e
char$(6) = "0010"         'f
char$(7) = "110"          'g
char$(8) = "0000"         'h
char$(9) = "00"           'i
char$(10) = "0111"         'j
char$(11) = "101"          'k
char$(12) = "0100"         'l
char$(13) = "11"           'm
char$(14) = "10"           'n
char$(15) = "111"          'o
char$(16) = "0110"         'p
char$(17) = "1101"         'q
char$(18) = "010"          'r
char$(19) = "000"          's
char$(20) = "1"            't
char$(21) = "001"          'u
char$(22) = "0001"         'v
char$(23) = "011"          'w
char$(24) = "1001"         'x
char$(25) = "1011"         'y
char$(26) = "1100"         'z
char$(27) = "11111"        '0
char$(28) = "01111"        '1
char$(29) = "00111"        '2
char$(30) = "00011"        '3
char$(31) = "00001"        '4
char$(32) = "00000"        '5
char$(33) = "10000"        '6
char$(34) = "11000"        '7
char$(35) = "11100"        '8
char$(36) = "11110"        '9
char$(37) = "010101"       '.
char$(38) = "110011"       ',
char$(39) = "001100"       '?
char$(40) = "111000"       ':
char$(41) = "100001"       '-
char$(42) = "011110"       ''
char$(43) = "10010"        '/
char$(44) = "101101"       '()
char$(45) = "010010"       '"

END SUB

SUB letter (char2)
bin$ = char$(char2)

FOR h = 1 TO LEN(bin$)
 IF h > 1 THEN SOUND 0, ditdahspace: LOCATE 1, 70: COLOR 7: PRINT "DIT"
 IF MID$(bin$, h, 1) = "0" THEN SOUND 900, dit: LOCATE 1, 70: COLOR 15: PRINT "DIT" 'diese beiden Zeilen
 IF MID$(bin$, h, 1) = "1" THEN SOUND 900, dah: LOCATE 1, 70: COLOR 15: PRINT "DAH" 'wurden geaendert
NEXT h

END SUB
